package Symulacja;

public class Abonent implements Comparable<Abonent>{


private short koniecRozmowy;
private int przejscie; // do ktorej komorki przechodzi

	public Abonent(){
		przejscie=0; // zostaje we wlasnej
		this.koniecRozmowy=0;
	}

	public int getKoniecRozmowy(){
		return koniecRozmowy;
	}

	public void aktualizujCzasRozmowy(){
	    if(this.koniecRozmowy>0)
	    	this.koniecRozmowy--;
	}
	public void zacznijRozmawiac(){
	  this.koniecRozmowy=(short)Symulacja.losujZrozkladuNormalnego(); 
	}

	public boolean czyRozmawia(){
		boolean flaga=false;
		if(this.koniecRozmowy>0)
			flaga=true;
		return flaga;
	}
	public int przejdzDoKomorki(){
		return Symulacja.losujInt(7);
	}
	public int getPrzejscie(){
		return this.przejscie;
	}

	public void setPrzejscie(int przej){
		this.przejscie=przej;
	}
	public void koniecRozmowy(){
		this.koniecRozmowy=0;
	}

 @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Abonent other = (Abonent) obj;
        if (this.koniecRozmowy != other.koniecRozmowy) {
            return false;
        }
        if (this.przejscie != other.przejscie) {
            return false;
        }
        return true;
    }

    @Override
    public int hashCode() {
        int hash = 5;
        hash = 53 * hash + this.koniecRozmowy;
        hash = 53 * hash + this.przejscie;
        return hash;
    }

    public int compareTo(Abonent o) {
       return (this.przejscie+this.koniecRozmowy)-(o.getPrzejscie()+this.getKoniecRozmowy());
    }


}


