package Symulacja;

import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;


public class Komorka {

private int id;
private static double prawd;
private static int kanaly;
private int[] sasiedzi;
private List<Abonent> abonenciRozmawiajacy;
private List<Abonent> abonenciNierozmawiajacy;
private List<Abonent> abonenciOczekujacyNaPrzejscie;

    public Komorka(){
    	abonenciRozmawiajacy=new LinkedList<Abonent>();
    	abonenciNierozmawiajacy=new LinkedList<Abonent>();
    	abonenciOczekujacyNaPrzejscie=new LinkedList<Abonent>();
    }
	public Komorka(int id){



		this.id=id;
		sasiedzi=new int[7];
		this.znajdzSasiadow(id);


		abonenciRozmawiajacy=new LinkedList<Abonent>();
		abonenciNierozmawiajacy=new LinkedList<Abonent>();
		abonenciOczekujacyNaPrzejscie=new LinkedList<Abonent>();
	}

	private void znajdzSasiadow(int id){

	  this.sasiedzi[0]=id;


      int przejscie=this.id;
	  int rozmiar=Symulacja.getRozmiar();

	  // dla 1

		if(id<rozmiar){
		 przejscie=rozmiar*rozmiar-id-1;

		}else if((id%(rozmiar*2))==0){
			przejscie=id-1;

		}else if((id%(rozmiar*2))<rozmiar){
			przejscie=id-rozmiar-1;

	    }else{
			przejscie=id-rozmiar;
		}

		this.sasiedzi[1]=przejscie;

       // dla  2
		if(id<rozmiar){
			 przejscie=rozmiar*rozmiar-id-1;

			}else if((id%(rozmiar*2))==(rozmiar+rozmiar-1)){
				przejscie=id -2*rozmiar +1;

			}else if((id%(rozmiar*2))<rozmiar){
				przejscie=id-rozmiar;

		    }else{
				przejscie=id-rozmiar+1;
			}
		this.sasiedzi[2]=przejscie;


	// dla 3
		if((id+1)%rozmiar==0){
		  przejscie=id-rozmiar+1;
		}else{
			przejscie=id+1;
		}

		this.sasiedzi[3]=przejscie;


	// dla 4
		if(id>=rozmiar*(rozmiar-1)){
			 przejscie=rozmiar*rozmiar-id-1;

			}else if((id%(rozmiar*2))==(rozmiar+rozmiar-1)){
				przejscie=id+1;

			}else if((id%(rozmiar*2))<rozmiar){
				przejscie=id+rozmiar;

		    }else{
				przejscie=id+rozmiar+1;
			}

		this.sasiedzi[4]=przejscie;


		// dla 5

		if(id>=rozmiar*(rozmiar-1)){
			 przejscie=rozmiar*rozmiar-id-1;

			}else if((id%(rozmiar*2))==0){
				przejscie=id+2*rozmiar-1;

			}else if((id%(rozmiar*2))<rozmiar){
				przejscie=id+rozmiar-1;

		    }else{
				przejscie=id+rozmiar;
			}
		this.sasiedzi[5]=przejscie;


	// dla 6
		if(id%rozmiar==0){
			  przejscie=id+rozmiar-1;
			}else{
				przejscie=id-1;
			}

      this.sasiedzi[6]=przejscie;

   //   for(int i=0;i<7;i++){
   // 	 System.out.print(this.sasiedzi[i]+" ");
    //  }
    //  System.out.println();

	}
	public void symulujZdarzenie(){

            //int k=this.abonenciRozmawiajacy.size();
        this.aktualizujCzasRozmowy();
          //int kk=this.abonenciRozmawiajacy.size();

        int ile=this.ileZacznieRozmowe();
     //   System.out.println(this.liczbaAbonentowRozmawiajacych()+" "+this.liczbaAbonentowNierozmawiajacych()+" "+ile);
	    List<Abonent> abonenci=new LinkedList<Abonent>();
	    Iterator<Abonent> iterr=abonenciNierozmawiajacy.iterator();
	    while(iterr!=null && iterr.hasNext() && ile>0){
	    	Abonent ab=iterr.next();
	    	ab.zacznijRozmawiac();
	    	iterr.remove();
	    	abonenci.add(ab);
	    	ile--;
	    }

	    Iterator<Abonent> it=abonenci.iterator();
	    while(it!=null && it.hasNext()){
	   	 this.dodajAbonenta(it.next());
	    }
      //    int kkk=this.abonenciRozmawiajacy.size();
   


    //      this.wyznaczAbonentowKtorzyChcaZmienicKomorke();

  //         int kkkk=this.abonenciRozmawiajacy.size();
//   System.out.println(k+" "+kk+" "+kkk+" "+kkkk);

    }

    private void aktualizujCzasRozmowy(){

      //  int k=this.abonenciRozmawiajacy.size();

        Iterator<Abonent> iter=abonenciRozmawiajacy.iterator();
	    while(iter!=null && iter.hasNext()){
	    	iter.next().aktualizujCzasRozmowy();
	    }

         List<Abonent> lista=new LinkedList<Abonent>();
         Iterator<Abonent> it=this.abonenciRozmawiajacy.iterator();
         while(it!=null && it.hasNext()){
           lista.add(it.next());
           it.remove();
	    }

         Abonent ab=null;
         Iterator<Abonent> iterator=lista.iterator();
         while(iterator!=null && iterator.hasNext()){
            ab=iterator.next();
            this.dodajAbonenta(ab);
            iterator.remove();
	    }

       //  System.out.println(k+" "+this.abonenciRozmawiajacy.size());
    }

	public void wyznaczAbonentowKtorzyChcaZmienicKomorke(){
		abonenciOczekujacyNaPrzejscie=new LinkedList<Abonent>();
		 Iterator<Abonent> iter=abonenciRozmawiajacy.iterator();
		 while(iter!=null && iter.hasNext()){
			Abonent ab=iter.next();
			int k=ab.przejdzDoKomorki();
			if(k>0){
				iter.remove();
				//System.out.println(sasiedzi[k]);
				ab.setPrzejscie(sasiedzi[k]);
				abonenciOczekujacyNaPrzejscie.add(ab);
			}
		 }
		 Iterator<Abonent> iterr=abonenciNierozmawiajacy.iterator();
		 while(iterr!=null && iterr.hasNext()){
				Abonent ab=iterr.next();
				int k=ab.przejdzDoKomorki();
				if(k>0){
					iterr.remove();
					ab.setPrzejscie(sasiedzi[k]);
					abonenciOczekujacyNaPrzejscie.add(ab);
				}
			}

	}
	public List<Abonent> przejdzDoKomorki(){

		return abonenciOczekujacyNaPrzejscie;
	}
	public int getId(){
		return id;
	}

	public void dodajAbonenta(Abonent k){

		int i=this.abonenciRozmawiajacy.size();
		if(k.czyRozmawia() && Komorka.getKanaly()>i){
		  this.abonenciRozmawiajacy.add(k);
		}else{
			k.koniecRozmowy();
			this.abonenciNierozmawiajacy.add(k);
		}
	}

	public int liczbaAbonentow(){
		return (abonenciRozmawiajacy.size()+abonenciNierozmawiajacy.size());
	}
	public int liczbaAbonentowRozmawiajacych(){
		return abonenciRozmawiajacy.size();
	}

	public int liczbaAbonentowNierozmawiajacych(){
		return abonenciNierozmawiajacy.size();
	}
public static void setKanaly(int kan){
	Komorka.kanaly=kan;
}

public static void setPrawd(double p){
   Komorka.prawd=p;
}
public static int getKanaly(){
	return Komorka.kanaly;
}

public static double getPrawd(){
   return Komorka.prawd;
}

private int silnia(int k){
	int silnia=1;

	for(int i=1; i<k+1;i++){
		silnia*=i;
	}

	return silnia;
}

private int ileZacznieRozmowe(){

   int k=abonenciNierozmawiajacy.size();
   k++;
 
    double d=Symulacja.losujDouble();
    double dystrybuanta=0;
    int ile=0;

     while(dystrybuanta<d && ile<k){
    	 dystrybuanta+= this.prawdPoissona(ile);
    	 ile++;
     }
    ile--;

  return ile;
}
private double prawdPoissona(int k){

	double lambda=Komorka.getPrawd()*this.abonenciNierozmawiajacy.size();
	return (Math.pow(lambda, k)*Math.pow(Math.E, -lambda))/this.silnia(k);

}

}

